hdu 1260 tickets

Tickets

**Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 1408 Accepted Submission(s): 687
**

Problem Description

Jesus, what a great movie! Thousands of people are rushing to the cinema. However, this is really a tuff time for Joe who sells the film tickets. He is wandering when could he go back home as early as possible.
A good approach, reducing the total time of tickets selling, is let adjacent people buy tickets together. As the restriction of the Ticket Seller Machine, Joe can sell a single ticket or two adjacent tickets at a time.
Since you are the great JESUS, you know exactly how much time needed for every person to buy a single ticket or two tickets for him/her. Could you so kind to tell poor Joe at what time could he go back home as early as possible? If so, I guess Joe would full of appreciation for your help.

Input

There are N(1<=N<=10) different scenarios, each scenario consists of 3 lines:

  1. An integer K(1<=K<=2000) representing the total number of people;
  2. K integer numbers(0s<=Si<=25s) representing the time consumed to buy a ticket for each person;
  3. (K-1) integer numbers(0s<=Di<=50s) representing the time needed for two adjacent people to buy two tickets together.

Output

For every scenario, please tell Joe at what time could he go back home as early as possible. Every day Joe started his work at 08:00:00 am. The format of time is HH:MM:SS am|pm.

Sample Input

2 2 20 25 40 1 8

Sample Output

08:00:40 am 08:00:08 am

dp

状态转移方程为dp[i]=min(dp[i-1]+a[i],dp[i-2]+b[i]) dp[i]为第i个人买完票所花的最少时间。a[i]和b[i]分别为单独买票和两个人一起买票的时间。

因为调试语句没删掉和错把B[I]的下表认为是从1开始(实际应从2开始) WA了两发 3A

 1
 2   
 3   #include <iostream>
 4   #include <cstdio>
 5   #include <algorithm>
 6   #include <cmath>
 7   #include <cstring>
 8   using namespace std;
 9   
10   int n,k;
11   const  int inf=99999999;
12   const int N=2E3+5;
13   bool am;
14   int a[N],b[N],dp[N],hour,mini,sec;
15   
16   int main()
17   {
18   
19       scanf("%d",&n);
20       while ( n-- )
21       {
22           am = true;
23           memset(a,0,sizeof(a));
24           memset(b,0,sizeof(b));
25           hour = 8;
26           mini = 0;
27         //  cout<<"hour1:"<<hour<<endl;
28           for ( int i = 0 ; i < N ; i++ )
29               dp[i] = 0;
30        //   cout<<"hour2:"<<hour<<endl;
31   
32           scanf("%d",&k);
33           for ( int i = 1; i <= k ; i++ )
34               scanf("%d",&a[i]);
35           for ( int i = 2 ; i <= k ; i++ )
36               scanf("%d",&b[i]);
37           dp[1] = a[1];
38           for ( int i = 2; i <= k ; i++ )
39               dp[i] = min(dp[i-1]+a[i],dp[i-2]+b[i]);
40       //    printf("%d\n",dp[k]);
41           sec = dp[k];
42        //   hour = 8;
43      //  cout<<"hour:"<<hour<<endl;
44           while (sec>=3600)
45           {
46               sec = sec - 3600 ;
47               hour++;
48           }
49           while (sec>=60)
50           {
51               sec = sec - 60 ;
52               mini++;
53           }
54           if ( hour>12 )
55           {
56               am = false;
57               hour = hour - 12;
58           }
59           if ( hour<10 )
60               cout<<"0";
61           cout<<hour<<":";
62           if ( mini<10 )
63               cout<<"0";
64           cout<<mini<<":";
65           if ( sec<10 )
66               cout<<"0";
67           if ( am )
68               cout<<sec<<" am"<<endl;
69           else cout<<sec<<" pm"<<endl;
70       }
71       return 0;
72   }
73